#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <math.h>
#include <Xm/Xm.h>
#include <Xm/XmAll.h>
#include <X11/keysym.h>
#include "bal1.xbm"
#include "bal2.xbm"
#include "bal3.xbm"
#include "bal4.xbm"
#include "beestl.xbm"
#include "beestr.xbm"
#define AI_DIZZY 0
#define AI_QUIET 1
#define AI_RON   2
inline int sqr(int a){
	return a*a;
}
inline float sqr(float a){
	return a*a;
}
#define TIME 60

int AI=AI_QUIET;
Pixmap bal[4], beestl, beestr;
XtAppContext app;
Display* display;
Screen* screen;
Window window;
Widget veld, message;
XtIntervalId klok=0; 
//kleuren
long unsigned foreGround, backGround, highLight, grey;
GC gcGray, gcBlack, gcWhite, gcSwitch;
GC gcXorOneBit;
// beest is 60 x 62
// bal is 50 x 50
//veld
Dimension width, height;
// linker beest, rechter beest
int lbxMin, lbxMax, lbyMin, lbyMax; //initialisatie gebeurt in eerste resize callback
int rbxMin, rbxMax, rbyMin, rbyMax;
int lbx, lby, rbx, rby;
int lbVx, lbVy, rbVx, rbVy;
int dempX=5, valVersnellingBeest=9;
int dVx=20, dVy=30; //snelheidsverandering bij toetsaanslag
int lbScore, rbScore;
//bal
int valVersnellingBal=1;
int dempBal=2;
int bxMin, bxMax, byMin, byMax;
int bx, by;
int bVx, bVy; 
void changeMessage(char* string=NULL){
	XmString s;
	char line[50];
	if(!string || !*string){
		sprintf(line, "%2d    X Arcade Volley by Dozo    %2d", lbScore, rbScore);
	} else
		sprintf(line, "%2d    %s    %2d", lbScore, string, rbScore);
	s=XmStringCreateLtoR(line, XmSTRING_DEFAULT_CHARSET);
	XtVaSetValues(message, XmNlabelString, s, XmNlabelType, XmSTRING, NULL);
	XmStringFree(s);
}
void stop(const char* var="default"){
	fprintf(stderr, "ERROR: %s\n",var);
	exit (1);
}
static void demand(int question, const char* var="default"){
	if(!(question)){
		fprintf(stderr, "error reading what should be: %s\n",var);
		exit (1);
	}
}
void schuifBeestr(int x, int y, int init=0){
	static int oldX = x, oldY = y;
	if(init){
		XCopyPlane(display, beestr, XtWindow(veld), gcWhite, 0, 0, beestl_width, beestl_height, x, y, 1);
	} else {
		XCopyPlane(display, beestr, XtWindow(veld), gcSwitch, 0, 0, beestl_width, beestl_height, oldX, oldY, 1);
		XCopyPlane(display, beestr, XtWindow(veld), gcSwitch, 0, 0, beestl_width, beestl_height, x, y, 1);
	}
	oldX=x; oldY=y;
}
void schuifBeestl(int x, int y, int init=0){
	static int oldX = x, oldY = y;
	if(init){
		XCopyPlane(display, beestl, XtWindow(veld), gcWhite, 0, 0, beestl_width, beestl_height, x, y, 1);
	} else {
		XCopyPlane(display, beestl, XtWindow(veld), gcSwitch, 0, 0, beestl_width, beestl_height, oldX, oldY, 1);
		XCopyPlane(display, beestl, XtWindow(veld), gcSwitch, 0, 0, beestl_width, beestl_height, x, y, 1);
	}
	oldX=x; oldY=y;
}
void schuifBal(int x, int y, int init=0){
  static int oldX, oldY;
	static int i=0;
	if(init){
		XCopyPlane(display, bal[i/2], XtWindow(veld), gcWhite, 0, 0, bal1_width, bal1_height, x, y, 1);
	} else {
  	XCopyPlane(display, bal[i++/2], XtWindow(veld), gcSwitch, 0, 0, bal1_width, bal1_height, oldX, oldY, 1);
		if(i==8)i=0;
  	XCopyPlane(display, bal[i/2], XtWindow(veld), gcSwitch, 0, 0, bal1_width, bal1_height, x, y, 1);
	}
	oldX=x; oldY=y;
}

void timerCallback(XtPointer client_data, XtIntervalId* id);
void pointScored(int speler){
	by=byMin;
	bVx=0; bVy=0;
	if(speler==0){ //er is geen timeout als deze functie wordt aangeroepen
		lbScore++;
		klok=0;
		bx=width/4-bal1_width/2+(6*rand()/RAND_MAX-3);
		if((lbScore>24) && (lbScore>rbScore+1)){
			changeMessage("Congratulations!!!");
			printf("Congratulations!!!\n");
			lbScore=0; rbScore=0;
			return;
		}
		changeMessage("Please Serve.");
	} else {
		rbScore++;
		if((rbScore>24) && (rbScore>lbScore+1)){
			changeMessage("I am the greatest!!!");
			printf("I am the greatest!!!\n");
			lbScore=0; rbScore=0;
			XtRemoveTimeOut(klok);
			klok=0;
			bx=width/4-bal1_width/2;
			return;
		}
		bx=width/4*3-bal1_width/2+(6*rand()/RAND_MAX-3) ;
		changeMessage(NULL);
	}
}

void timerCallback(XtPointer client_data, XtIntervalId* id){
	float cos, sin, r;
	float Vloodrecht, Vparallel, I;
	int D;
	int bVxCM, bVyCM;
	int bxCM, byCM;
	int hitNet;
	hitNet=0;
	//eerst de beesten verplaatsen, dan de bal
	//het balverplaatsingsalgoritme kan nooit de bal in een beest zetten
	//het beestperplaatsingsalgroitme hoeft hier dus niet op te letten
	/**** verandering in snelheid ****/
	if(lby<lbyMax)lbVy+=valVersnellingBeest; //als hij in de lucht hangt
	if(rby<rbyMax)rbVy+=valVersnellingBeest; //als hij in de lucht hangt
	bVy+=valVersnellingBal;
	/**** verandering in plaats ****/
	by+=bVy;
	bx+=bVx;
	/*** bal ***/
	if((by>byMax)&&(bVy>0)){ //neergaande beweging
		// bal raakt grond
		//by=2*byMax-by; //fysisch beter
		//by=byMax; //optisch beter
		//bVy=-bVy;
		pointScored(1-(bx+bal1_width/2)/(width/2));
		if(1-(bx+bal1_width/2)/(width/2)){
			klok=0;
		}
	} else if(by<byMin) { // raakt dak
		by=2*byMin-by;
		bVy=-bVy;
	}
	if(bx>bxMax){ //rechterwand
		bx=2*bxMax-bx;
		bVx=-bVx;
	} else if(bx<bxMin) { //linkerwand
		bx=2*bxMin-bx;
		bVx=-bVx;
	}
	/*** bal raakt net ***/
	if(((by+bal1_height)>=height/2) && 
		((((bx+bal1_width-width/2)*(bx-bVx+bal1_width-width/2)<0) && bVx>0) ||  // als de rechterkant door het net ging en bal -->
		(((bx-width/2)*(bx-bVx-width/2)<0) && bVx<0))){  //als de linkerkant door het net ging en bal <--
		hitNet=1;
		if((by+bal1_height/2)>=height/2){
			// vol in het net
			if(bVx<0){
				printf("<-- voor: %d, na: %d\n", bx-bVx-width/2, bx-width/2);
				bx=width/2;
				bVx/=-2;
			} else {
				printf("--> voor: %d, na: %d\n", bx-bVx+bal1_width-width/2, bx+bal1_width-width/2);
				bx=width/2-bal1_width;
				bVx/=-2;
			}
		} else {
			// tegen de bovenrand
			printf("randje\n");
		}
	}
	if(lbVx || lbVy){ // linker beest heeft snelheid
		lbx+=lbVx; lby+=lbVy;
		if(lbx<=lbxMin){
			lbx=lbxMin+2;
			lbVx=0;
		}
		if(lbx>=lbxMax){
			//net
			lbx=lbxMax-2;
			lbVx=0;
		}
		if(lby>=lbyMax){
			//grond
			lby=lbyMax;
			lbVy=0;
		}
		schuifBeestl(lbx, lby);
	}
	if(rbVx || rbVy){ // rechter beest heeft snelheid
		rbx+=rbVx; rby+=rbVy;
		if(rbx<=rbxMin){
			rbx=rbxMin+2;
			rbVx=0;
		}
		if(rbx>=rbxMax){
			// rechter wand
			rbx=rbxMax-2;
			rbVx=0;
		}
		if(rby>=rbyMax){
			//grond
			rby=rbyMax;
			rbVy=0;
		}
		schuifBeestr(rbx, rby);
	}
	/* BEGIN AI */
	if((bx+bal1_width/2)>width/2){ //bal is in rechter helft
		//gaan we rechterbeest bewegen?
		switch(AI){
		case AI_DIZZY:
			if(bx>rbx)rbVx=dVx;
			else if(bx<(rbx-10))rbVx=-dVx;
			if((by>(byMax-3*beestr_height)) && (by<(byMax-beestr_height)) && (rby==rbyMax))
				rbVy=-dVy;
			break;
		case AI_QUIET:
			if(bx+bVx>rbx)
				rbVx=dVx;
			else 
				if(bx+bVx<(rbx-beestl_width/2))rbVx=-dVx;
			else 
				rbVx=0;
			if((by>(byMax-2*beestr_height)) && (by<(byMax-beestr_height)) && (rby==rbyMax) && (sqr(bVx)+sqr(bVy)<100))
				rbVy=-dVy;
			rbVx+=-3+6*rand()/RAND_MAX;
			break;
		default:
			break;
		}
	} else {
		switch(AI){
		case AI_QUIET:
			if(rbx<(rbxMin+(rbxMax-rbxMin)/2-dVx))
				rbVx=dVx;
			else if(rbx>(rbxMin+(rbxMax-rbxMin)/2+dVx))
				rbVx=-dVx;
			else
				rbVx=0;
		default:
			break;
		}
	}
	/* END AI */
	if((bVx<0)){ //demp bal
		if(bVx<-40)bVx+=dempBal;
	} else {
		if(bVx>40)bVx-=dempBal;
	}
	if((bVy<0)){ //demp bal
		if(bVy<-40)bVy+=dempBal;
	} else {
		if(bVy>40)bVy-=dempBal;
	}
	//midden bal (bx+25, by+25)
	/**** bal raakt linker beest ****/
	if((sqr(bx-lbx)+sqr(by-lby))<2500){
		if(hitNet){
			if(by>(byMax-beestl_height/2)){ //ball hit beast too low
				printf("lost on net\n");
				pointScored(0);
				klok=0;
			} else {
				while((sqr(bx-lbx)+sqr(by-lby))<2500)by--;
				printf("lifting while net\n");
			}
		} else {
			//we gaan eerst de indringdiepte van de bal in termen van de snelheid bepalen
			//we gaan om te beginnen de cos en sin bepalen van de hoek die de lijn 
			//van middelpunt beest naar middelpunt bal maakt met de x-as
			bxCM=bx-lbx; byCM=by-lby;
			bVxCM=bVx-lbVx; //snelheden in Center of Mass (CM)
			bVyCM=bVy-lbVy;
			D=sqr(2*bxCM*bVxCM+2*byCM*bVyCM)-4*(sqr(bVxCM)+sqr(bVyCM))*(sqr(bxCM)+sqr(byCM)-4*sqr(25));
			I=(2.0*(bxCM*bVxCM+byCM*bVyCM)+sqrt(D))/(2*(sqr(bVxCM)+sqr(bVyCM)))   ; //indringtijd in ticks
			r=sqrt((sqr(bxCM-I*bVxCM)+sqr(byCM-I*bVyCM)));
			cos=(bxCM-I*bVxCM)/r;
			sin=(byCM-I*bVyCM)/r;
			r=sqrt((sqr(bxCM)+sqr(byCM)));
			Vloodrecht=  bVxCM*cos + bVyCM*sin;
			Vparallel=  -bVxCM*sin + bVyCM*cos;
			Vloodrecht=-Vloodrecht;
			bVx= int(Vloodrecht*cos - Vparallel*sin);
			bVy= int(Vloodrecht*sin + Vparallel*cos);
			//nu kloppen de snelheden, we willen ook de loodrechte positie inverteren zodat er nooit overlap is.
			bx+=int(2*cos*(50-r+1));
			by+=int(2*sin*(50-r+1));
			//printf("plaats: bx:%5d, by:%5d, lbx:%5d, lby:%5d, sqr:%d\n", bx, by, lbx, lby, (sqr(bx-lbx)+sqr(by-lby)));
			//printf("  cos:%5f, sin:%5f, r:%5f\n", cos, sin, r);
		}
	}
	/**** bal raakt rechter beest ****/
	if((sqr(bx-rbx)+sqr(by-rby))<2500){
		//we gaan eerst de indringdiepte van de bal in termen van de snelheid bepalen
		//we gaan om te beginnen de cos en sin bepalen van de hoek die de lijn 
		//van middelpunt beest naar middelpunt bal maakt met de x-as
		bxCM=bx-rbx; byCM=by-rby;
		bVxCM=bVx-rbVx; //snelheden in Center of Mass (CM)
		bVyCM=bVy-rbVy;
		D=sqr(2*bxCM*bVxCM+2*byCM*bVyCM)-4*(sqr(bVxCM)+sqr(bVyCM))*(sqr(bxCM)+sqr(byCM)-4*sqr(25));
		I=(2.0*(bxCM*bVxCM+byCM*bVyCM)+sqrt(D))/(2*(sqr(bVxCM)+sqr(bVyCM)))   ; //indringtijd in ticks
		r=sqrt((sqr(bxCM-I*bVxCM)+sqr(byCM-I*bVyCM)));
		cos=(bxCM-I*bVxCM)/r;
		sin=(byCM-I*bVyCM)/r;
		r=sqrt((sqr(bxCM)+sqr(byCM)));
		Vloodrecht=  bVxCM*cos + bVyCM*sin;
		Vparallel=  -bVxCM*sin + bVyCM*cos;
		Vloodrecht=-Vloodrecht;
		bVx= int(Vloodrecht*cos - Vparallel*sin);
		bVy= int(Vloodrecht*sin + Vparallel*cos);
		//nu kloppen de snelheden, we willen ook de loodrechte positie inverteren zodat er nooit overlap is.
		bx+=int(2*cos*(50-r+1));
		by+=int(2*sin*(50-r+1));
		//printf("plaats: bx:%5d, by:%5d, lbx:%5d, lby:%5d, sqr:%d\n", bx, by, lbx, lby, (sqr(bx-lbx)+sqr(by-lby)));
		//printf("  cos:%5f, sin:%5f, r:%5f\n", cos, sin, r);
	}
	schuifBal(bx, by); //staat vrijwel nooit stil;
	if(klok)klok=XtAppAddTimeOut(app, TIME, timerCallback, NULL); //ms, functie, client_data
}
void inputCallback(Widget w, XtPointer client_data, XtPointer call_data){
	XmDrawingAreaCallbackStruct* dacs = (XmDrawingAreaCallbackStruct *) call_data;
	XEvent* event=dacs->event;
	XKeyEvent key;
	int keySym;
	Window window=XtWindow(w);
	if(dacs->reason == XmCR_INPUT){ //only callback list this function was added to
		switch(event->type){
		case ButtonPress :
			XDrawPoint(display, window, gcWhite, dacs->event->xbutton.x, dacs->event->xbutton.y);
			printf("Jippie, een button press event\n");
			break;
		case KeyPress :
			if(!klok){//als de wetten der fysica nog niet gelden
				klok=XtAppAddTimeOut(app, TIME, timerCallback, NULL); //ms, functie, client_data
				changeMessage(NULL); //voor als we van een pause komen, bij begingame is dit al zo
			}
			key=event->xkey;
			keySym=XLookupKeysym(&key, 0);
			switch(keySym){
				case XK_Left :
					lbVx=-dVx;
					break;
				case XK_Right :
					lbVx=dVx;
					break;
				case XK_Up :
					if(lby==lbyMax)lbVy=-dVy;
					break;
				case XK_Escape :
					printf("Have a nice X session.\n");
					XAutoRepeatOn(display); //on causes keeping a key down to cause several press-release pairs
					exit(0);
				case XK_p :
					XtRemoveTimeOut(klok);
					klok=0;
					changeMessage("Game paused");
					break;
				default :
					printf("Don\'t push me!\n");
					break;
			}
			break;
		case KeyRelease :
			key=event->xkey;
			keySym=XLookupKeysym(&key, 0);
			switch(keySym){
			case XK_Left :
			case XK_Right :
				lbVx=0;
				break;
			default :
				break;
		}
		default :
			break;
		}
	} else {
		fprintf(stderr, "Major trouble, you have a lousy X server.\n");
		exit(1);
	}
}

void resizeCallback(Widget w, XtPointer client_data, XtPointer call_data){
	printf("Joepie een resize event.\n");
	XmDrawingAreaCallbackStruct* dacs = (XmDrawingAreaCallbackStruct *) call_data;
	XEvent* event=dacs->event;
	XtVaGetValues(w, XmNwidth, &width, XmNheight, &height, NULL);
	printf("width: %ud, height: %ud\n", width, height);

	//globalen beest
	lbScore=0; rbScore=0;
	lbyMax=height-beestl_height;
	rbyMax=height-beestr_height;
	lbxMin=0; lbxMax=width/2-beestl_width-2;
	rbxMin=width/2+2; rbxMax=width-beestr_width-1;
	lbx=lbxMin+10; lby=lbyMax; rbx=rbxMax-10, rby=lbyMax;
	lbVx=0; lbVy=0; rbVx=0; rbVy=0;

	//globalen bal
	bxMin=0; bxMax=width-bal1_width-1;
	byMin=0; byMax=height-bal1_height-1;
	bx=width/4-bal1_width/2; by=byMin;
	bVx=0, bVy=0;
	printf("end resize\n");
}

void exposeCallback(Widget w, XtPointer client_data, XtPointer call_data){
	XmDrawingAreaCallbackStruct* dacs = (XmDrawingAreaCallbackStruct *) call_data;
	XEvent* event=dacs->event;
	Window window=XtWindow(w);
	printf("Joepie een expose event.\n");
	Boolean firstTime=True;
	if(firstTime){
		XSetWindowAttributes xswa;
		firstTime = False;
		xswa.bit_gravity = ForgetGravity;
		XChangeWindowAttributes(XtDisplay(w), window, CWBitGravity, &xswa);
	}
	XFillRectangle(display, window, gcBlack, 0, 0, width, height); //let op, niet width-1
		//dit lijkt overdreven, geloof me, het is nodig
	schuifBeestl(lbx, lby, 1);
	schuifBeestr(rbx, rby, 1);
	schuifBal(bx, by, 1);
	XFillRectangle(display, window, gcWhite, width/2-2, height/2-1, 5, height/3*2); //net
		//breedte 2 betekent dat de xwaarde_rechter_lijn == xwaarde_linker_lijn+2 bij XDrawRectangle
		//breedte 2 betekent dat de xwaarde_rechter_lijn == xwaarde_linker_lijn+1 bij XFillRectangle
}
void opponentCB(Widget widget, XtPointer clientData, XtPointer callData){
}
void aiCB(Widget widget, XtPointer clientData, XtPointer callData){
	AI=(int)clientData; //this function is called twice when changing a radiobutton
		//first for the one unset, than the one set
}
main(int argc, char* argv[]){
	int ac; Arg al[10]; //argument count and argument list, in case not using VA variant for x functions
	int i;
	Widget toplevel, main, menuBar;
	Widget opponentMenu, aiMenu;
	toplevel = XtVaAppInitialize(&app, "xav", NULL, 0, &argc, argv, NULL, 
		XmNheight, 400, XmNwidth, 600,
		NULL);

//## set display and screen 
	display = XtDisplay(toplevel);
	screen = XtScreen(toplevel);
	window = RootWindowOfScreen(screen); //the real window is not known untill first expose

//## keyboard preferences like bell and auto-repeat
	XAutoRepeatOn(display); //on causes keeping a key down to cause several press-release pairs

//## laad bal1-bal4 in Xserver
	//#define bal1_width 50 #define bal1_height 50
	bal[0] = XCreateBitmapFromData(display, window, bal1_bits, bal1_width, bal1_height);
	bal[1] = XCreateBitmapFromData(display, window, bal2_bits, bal2_width, bal2_height);
	bal[2] = XCreateBitmapFromData(display, window, bal3_bits, bal3_width, bal3_height);
	bal[3] = XCreateBitmapFromData(display, window, bal4_bits, bal4_width, bal4_height);
	//#define beestl_width 60 #define beestl_height 62
	beestl = XCreateBitmapFromData(display, window, beestl_bits, beestl_width, beestl_height);
	beestr = XCreateBitmapFromData(display, window, beestr_bits, beestr_width, beestr_height);
		

//## colour things
	//probeVisual(display, screen, &foreGround, &backGround, &grey, &highLight);
	//no colours in this game
//## do some initialisation for display and screen (quite messy still)
	XGCValues gcv;
	gcv.foreground = BlackPixelOfScreen(screen);
	gcv.background = BlackPixelOfScreen(screen);
	gcBlack = XCreateGC (display, RootWindowOfScreen(screen), GCForeground | GCBackground, &gcv);
	gcv.foreground = WhitePixelOfScreen(screen);
	gcWhite = XCreateGC (display, RootWindowOfScreen(screen), GCForeground | GCBackground, &gcv);
	gcv.foreground = WhitePixelOfScreen(screen) ^ BlackPixelOfScreen(screen);
		// fore ^ (B^W) = back; back ^ (B^W) = fore
	gcv.background = 0; // 0 ^ something = something
	gcv.function = GXxor;
	gcSwitch = XCreateGC (display, RootWindowOfScreen(screen), GCForeground | GCBackground | GCFunction, &gcv);
		//this GC switches between screen's foreground and background
	gcv.foreground = 1;
	gcv.background = 0;
	gcXorOneBit = XCreateGC (display, RootWindowOfScreen(screen), GCForeground | GCBackground | GCFunction, &gcv);

//## define widget hierarchy
	main = XtVaCreateManagedWidget("main", xmMainWindowWidgetClass, toplevel, NULL);
		XmString Opponent=XmStringCreateLocalized("Opponent");
			XmString AI=XmStringCreateLocalized("AI");
			XmString AIwaiting=XmStringCreateLocalized("AI but waiting");
			XmString Waiting=XmStringCreateLocalized("Waiting");
			XmString Dizzy=XmStringCreateLocalized("Dizzy");
			XmString Quiet=XmStringCreateLocalized("Quiet");
			XmString Ron=XmStringCreateLocalized("Ron");
		XmString Help=XmStringCreateLocalized("Help");
		menuBar=XmVaCreateSimpleMenuBar(main, "menuBar", 
			XmVaCASCADEBUTTON, Opponent, 'O',
			XmVaCASCADEBUTTON, AI, 'A',
			XmVaCASCADEBUTTON, Help, 'H',
			NULL);
		XtVaSetValues(menuBar, XmNmenuHelpWidget, XtNameToWidget(menuBar, "button_2"), NULL); //give help special pos
		opponentMenu=XmVaCreateSimplePulldownMenu(menuBar, "opponentMenu", 0, opponentCB,
			XmVaPUSHBUTTON, AI, 'A', NULL, NULL,
			XmVaPUSHBUTTON, AIwaiting, 'I', NULL, NULL,
			XmVaPUSHBUTTON, Waiting, 'W', NULL, NULL,
			XmVaSEPARATOR,
			NULL);
		XtVaSetValues(XtNameToWidget(opponentMenu, "button_1"), XmNsensitive, False, NULL); //just for now
		XtVaSetValues(XtNameToWidget(opponentMenu, "button_2"), XmNsensitive, False, NULL); //just for now
		aiMenu=XmVaCreateSimplePulldownMenu(menuBar, "aiMenu", 1, aiCB,
			XmVaRADIOBUTTON, Dizzy, 'D', NULL, NULL,
			XmVaRADIOBUTTON, Quiet, 'Q', NULL, NULL,
			XmVaRADIOBUTTON, Ron, 'R', NULL, NULL,
				/* RowColumn resources to enforce */
			XmNradioBehavior, True,    
				/* select radio behavior in Menu */ 
			XmNradioAlwaysOne, True,   
			NULL);
		XtVaSetValues(XtNameToWidget(aiMenu, "button_2"), XmNsensitive, False, NULL); //just for now
		XmStringFree(Opponent);
			XmStringFree(AI);
			XmStringFree(AIwaiting);
			XmStringFree(Waiting);
			XmStringFree(Dizzy);
			XmStringFree(Quiet);
			XmStringFree(Ron);
		XmStringFree(Help);
		XtManageChild(menuBar);
		veld = XtVaCreateManagedWidget("veld", xmDrawingAreaWidgetClass, main, 
			XmNbackground, BlackPixelOfScreen(screen), 
			XmNwidth, width,
			XmNheight, height,
			NULL);
		message = XtVaCreateManagedWidget("message", xmLabelWidgetClass, main,
			NULL);
		changeMessage(NULL);
		XtVaSetValues(main,
			XmNmenuBar,    menuBar,
			//XmNworkWindow, veld,
			XmNmessageWindow, message,
			NULL);

//## define callbacks
	XtAddCallback(veld, XmNinputCallback, inputCallback, NULL); //input, expose, resize
	XtAddCallback(veld, XmNexposeCallback, exposeCallback, NULL); //input, expose, resize
	XtAddCallback(veld, XmNresizeCallback, resizeCallback, NULL); //input, expose, resize
	
	//XBananas(); //no sound please
//## make widgets visible and enter main loop
	XtRealizeWidget(toplevel); // veld bestaat niet voor dit punt
	XtAppMainLoop(app);
}

